
/*
 * Headerfile for the Main Window with preferences
 * Copyright (c) 1998 - Stig Erik Sand
 *
 * $Id: PrefDialog.h,v 1.15 1998/06/18 22:56:04 stig Exp $
 */

#ifndef PrefDialog_included
#define PrefDialog_included

#include "PrefDialogData.h"
#include "tools.H"

class PaintArea;

class PrefDialog : public PrefDialogData
{
    Q_OBJECT
    
public:

    PrefDialog(QWidget* parent = NULL, const char* name = NULL);
    virtual ~PrefDialog();

    const PrefStruct *getPrefs() const {
//	printf("Inf: %s\n", prefs.infilename);
	return &prefs;
    }
    void updateInfile();
	
 protected slots:
    virtual void saveVars();
    virtual void getInfile();
    virtual void getOutfile();
    virtual void getStatfile();
    virtual void algoSelect(int);
    virtual void about();

 private:

    void doActualSave();
    
    PaintArea *paintarea;
    PrefStruct prefs;
};

#endif // PrefDialog_included
