#ifndef PAINTAREA_H
#define PAINTAREA_H

/*
 * Class declaration for the painting area
 * Copyright (c) 1998 - Stig Erik Sand
 *
 * $Id: paintarea.H,v 1.11 1998/05/27 12:43:03 stig Exp $
 */

class QPopupMenu;
class PrefDialog;
class QImage;
class QPixmap;
class Mosaic;

#include <qwidget.h>

class PaintArea : public QWidget {
    Q_OBJECT
public:
    PaintArea(const char* name, PrefDialog*);
    ~PaintArea();

    void displayPicture(QImage *);
public slots:
    void startProcess();
    void pasteInAlternative(int);
    void splitInfile();    
protected:
    virtual void paintEvent ( QPaintEvent * );
    int usedPictures(int) const;
    
protected slots:
    void mousePressEvent(QMouseEvent *);
    void saveAsPrintable();
    
private:
    /** Popup menus when right mouse clicked */
    QPopupMenu *popmen, *pictlist;
    /** The Mosaic representation */
    Mosaic *theMosaic;
    /** The original image */
    QImage *originalImage;
    /** Size of the picture */
    unsigned int picWidth, picHeight;
    /** The preferences */
    PrefDialog *prefs;
    /** Temp variable */
    int whichtile;
    /** The pixmap used for painting */
    QPixmap *thepixmap;
};

#endif /* PAINTAREA_H */

