#ifndef PICTURE_H
#define PICTURE_H

/*
 * Headerfile for the Picture-related classes
 * Copyright (c) 1998 - Stig Erik Sand
 *
 * $Id: picture.H,v 1.11 1998/08/01 12:43:48 stig Exp $
 */

/* Classes and stuff */

class RGBColour {
public:
    RGBColour(unsigned char a=0, unsigned char b=0, unsigned char c=0)
	: red(a), green(b), blue(c) { }

    int howEqual(const RGBColour&) const;
    int darkLevel() const;
    int dark() const;
    int light() const;
    
//private:
    unsigned char red, green, blue;
};

class Coord {
public:
    Coord(int a=-1, int b=-1) : x(a), y(b), colour(-1,-1,-1) { }
    int x, y;
    RGBColour colour;
};

#define COORD_NUMBER 100
#define DARK_NUMBER 9
#define BASIC_ALLOW 1
//#define SECOND_ALLOW 2

class PicturePart {
    
public:
    PicturePart(Coord tl=Coord(), Coord br=Coord());
    void calculateDescr();
    int equalitySum(const PicturePart&, int all, int checkd=0) const;
    
    Coord coords[COORD_NUMBER];
private:
    int dark[DARK_NUMBER];
};

class AlternativePicture {
public:
    char name[80];
    char flipped;
    PicturePart data;
    int width, height;
};


class ostream;
class QImage;
class QPixmap;

class TiledPicture {
public:
    TiledPicture(const QImage *pct, int tX, int tY, int irr=0);
    ~TiledPicture();
    
    const PicturePart* getParts(unsigned int &len) const {
	len=howmany;
	return parts;
    }
    const QPixmap* getPartPixmaps() const { return partPictures; }
    static QPixmap getPartOfPicture(const QImage *pct, int x, int y, int tX, int tY);
    
    int getWidth() const { return width; }
    int getHeight() const { return height; }
    
private:
    PicturePart *parts;
    QPixmap *partPictures;
    unsigned int howmany;
    int width, height;
};

#endif /* PICTURE_H */

